<template>
  <div class="app-container">
    <!-- 搜索 -->
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="管理耳号" prop="manageTags">
        <el-input v-model="queryParams.manageTags" placeholder="请输入管理耳号" clearable @keyup.enter="handleQuery" />
      </el-form-item>

      <el-form-item label="羊舍" prop="sheepfold">
        <el-select v-model="queryParams.sheepfold" placeholder="请选择羊舍" style="min-width:150px" clearable>
          <el-option v-for="item in sheepfoldOptions" :key="item.id" :label="item.sheepfoldName" :value="item.id" />
        </el-select>
      </el-form-item>

      <el-form-item label="品种" prop="varietyId">
        <el-select v-model="queryParams.varietyId" placeholder="请选择品种" style="min-width:150px" clearable>
          <el-option v-for="item in varietyOptions" :key="item.id" :label="item.variety" :value="item.id" />
        </el-select>
      </el-form-item>

      <el-form-item label="创建时间" style="width: 308px">
        <el-date-picker v-model="daterangeCreateTime" value-format="YYYY-MM-DD" type="daterange" range-separator="-"
          start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 按钮 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd"
          v-hasPermi="['fixHoof:fixHoof:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['fixHoof:fixHoof:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['fixHoof:fixHoof:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['fixHoof:fixHoof:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" />
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="fixHoofList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="耳号" align="center" prop="manageTags" />
      <el-table-column label="羊舍名称" align="center" prop="sheepfoldName" />
      <el-table-column label="品种" align="center" prop="varietyName" />
      <el-table-column label="备注" align="center" prop="comment" />
      <el-table-column label="技术员" align="center" prop="technician" />
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['fixHoof:fixHoof:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['fixHoof:fixHoof:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 弹窗 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="fixHoofRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="耳号" prop="manageTags">
          <el-input v-model="form.manageTags" placeholder="请输入耳号" @blur="validateSheep" />
        </el-form-item>
        <el-form-item label="羊舍" prop="sheepfold">
          <el-select v-model="form.sheepfold" placeholder="请选择羊舍" clearable>
            <el-option v-for="fold in sheepfoldOptions" :key="fold.id" :label="fold.sheepfoldName" :value="fold.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="品种" prop="varietyId">
          <el-select v-model="form.varietyId" placeholder="请选择品种" clearable>
            <el-option v-for="item in varietyOptions" :key="item.id" :label="item.variety" :value="item.id" />
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="comment">
          <el-input v-model="form.comment" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="技术员" prop="technician">
          <el-input v-model="form.technician" placeholder="请输入技术员" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="FixHoof">
import { listFixHoof, getFixHoof, delFixHoof, addFixHoof, updateFixHoof, checkSheepByManageTags, getVarietyOptions } from '@/api/produce/other/fixHoof/fixHoof'
import { listSheepfold_management as listSheepfold } from '@/api/fileManagement/sheepfold_management'
// import request from '@/utils/request'

const { proxy } = getCurrentInstance()

const fixHoofList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref('')
const daterangeCreateTime = ref([])
const varietyOptions = ref([])

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    sheepId: null,
    sheepfold: null,
    varietyId: null,
    technician: null,
    createTime: null
  },
  rules: {
    // sheepId: [
    //   { required: true, message: '耳号不能为空', trigger: 'blur' }
    // ],
    manageTags: [
      { required: true, message: '耳号不能为空', trigger: 'blur' }
    ],
    sheepfold: [
      { required: true, message: '羊舍id不能为空', trigger: 'change' }
    ],
    varietyId: [
      { required: true, message: '品种不能为空', trigger: 'change' }
    ],
    technician: [
      { required: true, message: '技术员不能为空', trigger: 'blur' }
    ]
  }
})

const { queryParams, form, rules } = toRefs(data)

/* 列表 */
function getList() {
  loading.value = true
  const q = { ...queryParams.value }
  if (q.sheepId === '') q.sheepId = null
  if (q.sheepfold === '') q.sheepfold = null
  q.params = {}
  if (daterangeCreateTime.value?.length) {
    q.params.beginCreateTime = daterangeCreateTime.value[0]
    q.params.endCreateTime = daterangeCreateTime.value[1]
  }
  listFixHoof(q).then(res => {
    fixHoofList.value = res.rows
    total.value = res.total
    loading.value = false
  })
   getVarietyOptions({ pageNum: 1, pageSize: 9999 }).then(res => {
    varietyOptions.value = res.rows || []
  })
}

function cancel() {
  open.value = false
  reset()
}

function reset() {
  form.value = {
    id: null,
    sheepId: null,
    sheepfold: null,
    varietyId: null,
    comment: null,
    technician: null,
    createBy: null,
    createTime: null
  }
  proxy.resetForm('fixHoofRef')
}

function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

function resetQuery() {
  daterangeCreateTime.value = []
  proxy.resetForm('queryRef')
  handleQuery()
}

function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length !== 1
  multiple.value = !selection.length
}

function handleAdd() {
  reset()
  open.value = true
  title.value = '添加修蹄'
}

function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getFixHoof(_id).then(res => {
    form.value = res.data
    open.value = true
    title.value = '修改修蹄'
  })
}

function submitForm() {
  proxy.$refs.fixHoofRef.validate(valid => {
    if (!valid) return
    if (form.value.id) {
      updateFixHoof(form.value).then(() => {
        proxy.$modal.msgSuccess('修改成功')
        open.value = false
        getList()
      })
    } else {
      addFixHoof(form.value).then(() => {
        proxy.$modal.msgSuccess('新增成功')
        open.value = false
        getList()
      })
    }
  })
}

function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm(`是否确认删除修蹄编号为"${_ids}"的数据项？`).then(() => {
    return delFixHoof(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess('删除成功')
  })
}

function handleExport() {
  proxy.download('/produce/other/fixHoof/export', { ...queryParams.value }, `fixHoof_${new Date().getTime()}.xlsx`)
}

/* 羊舍 */
const sheepfoldOptions = ref([])
function getSheepfoldOptions() {
  listSheepfold({ pageNum: 1, pageSize: 9999 }).then(res => {
    sheepfoldOptions.value = res.rows
  })
}

//校验羊只是否存在 失焦时校验
async function validateSheep() {
  if (!form.value.manageTags) return;
  try {
    const { data } = await checkSheepByManageTags(form.value.manageTags.trim())
    if (!data) {
      proxy.$modal.msgError('该管理耳号不存在');
      // 清空
      form.value.manageTags = null;
      form.value.sheepId = null;
      form.value.sheepfold = null;
      form.value.varietyId = null;
    } else {
      // 隐藏字段：真正保存用
      form.value.sheepId = data.id;
      // 自动带出下拉框
      form.value.sheepfold = data.sheepfoldId;
      form.value.varietyId = data.varietyId;
    }
  } catch {
    proxy.$modal.msgError('校验失败');
  }
}

/* 只保留一个 onMounted */

  getList()
  getSheepfoldOptions()
  getVarietyOptions()

</script>